dofile_once("data/scripts/lib/utilities.lua")


---------------------------------------------------------------------------------------------------------------------------------

function get_player()
  return EntityGetWithTag( "player_unit" )[1]
end

----------------------------------------------------------------------------------------------------------------------------------

--[[
最後に手に持っていた（いる）杖のentity_idを取得する関数（定義箇所dofile_once("data/scripts/gun/procedural/gun_actions_utils.lua）
wand_id = find_the_wand_held( get_player())
]]--

function get_wand_id_hand( entity_id )

	local children = EntityGetAllChildren( entity_id )
	if( children == nil ) then return 0 end

	local backup_result = 0

	-- Inventory2Component
	-- mActiveItem
	local inventory2_comp = EntityGetFirstComponentIncludingDisabled( entity_id, "Inventory2Component" )
	if( inventory2_comp ~= nil ) then
		local active_item = ComponentGetValue( inventory2_comp, "mActiveItem" )
		if( EntityHasTag( active_item, "wand" ) ) then
			return active_item
		end
	end
	
	-- if that doesn't work (e.g. player is holding something else than a wand)
	for i,child in ipairs( children ) do
		if( EntityHasTag( child, "wand" ) ) then
			if( ComponentGetIsEnabled( EntityGetFirstComponent( child, "ItemComponent") ) ) then
				return child
			end
			if( ComponentGetIsEnabled( EntityGetFirstComponentIncludingDisabled(child, "ItemComponent") ) ) then
				backup_result = child
			end
		else
			local temp_result = get_wand_id_hand( child )
			if( temp_result ~= 0 ) then
				if( ComponentGetIsEnabled( EntityGetFirstComponent( temp_result, "ItemComponent") ) ) then
					return temp_result
				else
					backup_result = temp_result
				end
			end
		end
	end

	return backup_result
end

----------------------------------------------------------------------------------------------------------------------------------
--[[ｲﾝﾍﾞﾝﾄﾘの位置を選択し、wand_idを取得する関数]]--

function get_wand_id_inv(inventory_number)

  --get_player_cildren_table
  local player_id = EntityGetWithTag( "player_unit" )[1]
  local player_children = EntityGetAllChildren(player_id)

  --get_inventory_wand_id
  for i,entity  in ipairs(player_children) do
       local entitiy_name = EntityGetName( entity )
       if  entitiy_name == "inventory_quick" then
            if entity ~= nil then
                 local inventory_id = entity

                 --get_wand_entity_id
                 local inventory_table = EntityGetAllChildren(inventory_id)
                 local wand_id = inventory_table[inventory_number]
                 local testtext ="get_wand_id"
                       print(testtext)
                       return wand_id
            end
       end
  end
end

-----------------------------------------------------------------------------------------------------------------------------------
--[[杖内のItemAction_idのテーブルを返す。基本的に杖内の左から順番に要素数が若いが、常時詠唱は追加した要素数を維持する]]--
function get_wand_actions(wand_id)

local wand_actions = {}
local wand_children = EntityGetAllChildren(wand_id)
for i,entity in ipairs(wand_children) do
      local is_pro = EntityHasTag(entity,"card_action")
      if not is_pro then
      else
           table.insert(wand_actions,entity)
           local count = #wand_actions
           print(count)
      end
end
return wand_actions
end
-----------------------------------------------------------------------------------------------------------------------------------
--[[杖内の魔法IDテーブルを返す。常時詠唱の物は先頭に入ると同時に、要素数のテーブルも返す
     return action_id = {},常時詠唱の要素数{}]]--

function wand_actions_id(wand_id)
     local actions_id = {}
     local permanently_idx = {}
     local per_count = 0

if ( wand_id ~= nil ) then
     local wand_actions = get_wand_actions(wand_id)

     for i=1,#wand_actions do
           local item_component = EntityGetFirstComponentIncludingDisabled(  wand_actions[i], "ItemComponent" )

	      if( item_component ~= nil ) then 
                    local permanently = ComponentGetValue( item_component, "permanently_attached" )

                    if ( permanently == "1" ) then 
                    local per_count = per_count + 1
                          table.insert(permanently_idx, per_count)

                    local itemaction_component = EntityGetFirstComponentIncludingDisabled(  wand_actions[i], "ItemActionComponent" )                                
              
                          if ( itemaction_component ~= nil ) then
                          local action_id = ComponentGetValue( itemaction_component, "action_id" )

                                if action_id ~= nil then
                                      table.insert(actions_id, action_id)
                                end
                          end
                    end
              end
     end
     for i=1,#wand_actions do

           local item_component = EntityGetFirstComponentIncludingDisabled(  wand_actions[i], "ItemComponent" )

	      if( item_component ~= nil ) then 
                    local permanently = ComponentGetValue( item_component, "permanently_attached" )

                    if (permanently ~= "1") then   
                    
                         local itemaction_component = EntityGetFirstComponentIncludingDisabled(  wand_actions[i], "ItemActionComponent" )                                
              
                             if ( itemaction_component ~= nil ) then
                                                
                                 local action_id = ComponentGetValue( itemaction_component, "action_id" )

                                 if action_id ~= nil then
                                      table.insert(actions_id, action_id)
                                end
                            end         
                    end  
         end
      end
end
return actions_id, permanently_idx
end


-----------------------------------------------------------------------------------------------------------------------------------
--[[杖内の一番左の常時詠唱を外す]]--
function wand_remove_first_permanently ( wand_id )

local wand_actions = get_wand_actions( wand_id )

for i=1,#wand_actions do
           local item_component = EntityGetFirstComponentIncludingDisabled(  wand_actions[i], "ItemComponent" )

	      if( item_component ~= nil ) then 
                    local permanently = ComponentGetValue( item_component, "permanently_attached" )
                    if ( permanently == "1" ) then 
                          ComponentSetValue( item_component, "permanently_attached", "0" )
                    return 
                    end
          end
end
end
-----------------------------------------------------------------------------------------------------------------------------------

--[[この関数は今持っている杖4本を手に持った際に"directory"Luaが動作するようにする
　　player_idのLuaComponentにこの関数を実行し続けるLuaを追加する必要がある]]--

function hand_id_init(lua_directory)

local directory = tostring(lua_directory)

if not directory then return end

for i=1,4 do
      local wand_id = get_wand_inv(i)
            edit_component2(wand_id, "LuaComponent", function(comp)
　　　　　　　　　comp._tags= "enabled_in_hand"
                  comp.script_source_file= directory
		  comp.execute_every_n_frame="-1"
		  comp.remove_after_executed="1"
               end)     
end
end

--[[このをinit.lua追加するといい
function  OnPlayerSpawned (player_entity)
edit_component2(player_entitiy, "LuaComponent", function(comp)
　　　　　　　　　comp.script_source_file= "パスも含めたLuaファイル名"
		  comp.execute_every_n_frame="10"
		  comp.remove_after_executed="0"
               end)
end
]]--


-----------------------------------------------------------------------------------------------------------------------------------

function str(var)

  if type(var) == 'table' then
    local s = '{ '
    for k,v in pairs(var) do
      if type(k) ~= 'number' then k = '"'..k..'"' end
      s = s .. '['..k..'] = ' .. str(v) .. ','
    end
    return s .. '} '
  end
  return tostring(var)
end

-------------------------------------------------------------------------------------------------------------------------------------

function debug_entity(e)

    local parent = EntityGetParent(e)
    local children = EntityGetAllChildren(e)
    local comps = EntityGetAllComponents(e)

    print("--- ENTITY DATA ---")
    print("Parent: ["..parent.."] " .. (EntityGetName(parent) or "nil"))

    print(" Entity: ["..str(e).."] " .. (EntityGetName(e) or "nil"))
    print("  Tags: " .. (EntityGetTags(e) or "nil"))
    if (comps ~= nil) then
      for _, comp in ipairs(comps) do
          print("  Comp: ["..comp.."] " .. (ComponentGetTypeName(comp) or "nil"))
      end
    end

    if children == nil then return end

    for _, child in ipairs(children) do
        local comps = EntityGetAllComponents(child)
        print("  Child: ["..child.."] " .. EntityGetName(child))
        for _, comp in ipairs(comps) do
            print("   Comp: ["..comp.."] " .. (ComponentGetTypeName(comp) or "nil"))
        end
    end
    print("--- END ENTITY DATA ---")
end
